
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>LSTM Chemistry Training Colab &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Useful Dictionaries" href="main.html" />
    <link rel="prev" title="Normalisation Training Colab" href="normalisation_training.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 current active nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <p class="caption">
 <span class="caption-text">
  Contents:
 </span>
</p>
<ul class="current nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="training_colab.html">
   Training Colab
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="normalisation_training.html">
   Normalisation Training
  </a>
 </li>
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   LSTM Chemistry Training
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}
</style>
<div class="section" id="LSTM-Chemistry-Training-Colab">
<h1><strong>LSTM Chemistry Training Colab</strong><a class="headerlink" href="#LSTM-Chemistry-Training-Colab" title="Permalink to this headline">¶</a></h1>
<p>This Colab serves for training <code class="docutils literal notranslate"><span class="pre">LSTM_chemistry</span></code> models.</p>
<p>The following google drive link corresponds to the most recent project folder(you’ll need to ask for access): <a class="reference external" href="https://drive.google.com/drive/folders/1iZtHF_jrLXeIBbAIk5AXBtS-5Ib6sCQ7?usp=sharing">https://drive.google.com/drive/folders/1iZtHF_jrLXeIBbAIk5AXBtS-5Ib6sCQ7?usp=sharing</a></p>
<p>The following cell includes the bare minimum to mount google drive to google colab so that the files can be directly called. The <code class="docutils literal notranslate"><span class="pre">folder_name</span></code> may have to be updated to the latest <code class="docutils literal notranslate"><span class="pre">Battery_SOH</span></code> folder.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">google.colab</span> <span class="kn">import</span> <span class="n">drive</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>

<span class="c1"># Mounting google drivee</span>
<span class="n">drive</span><span class="o">.</span><span class="n">mount</span><span class="p">(</span><span class="s1">&#39;/content/gdrive&#39;</span><span class="p">)</span>
<span class="n">folder_name</span> <span class="o">=</span> <span class="s1">&#39;Battery_SOH_final&#39;</span>
<span class="c1"># The root path will change depending on the latest &#39;bakcup&#39;</span>
<span class="n">root_path</span> <span class="o">=</span> <span class="s1">&#39;gdrive/My Drive/battery_soh/&#39;</span> <span class="o">+</span> <span class="n">folder_name</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">root_path</span><span class="p">)</span>
<span class="n">device</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">device</span><span class="p">(</span><span class="s1">&#39;cuda:0&#39;</span> <span class="k">if</span> <span class="n">th</span><span class="o">.</span><span class="n">cuda</span><span class="o">.</span><span class="n">is_available</span><span class="p">()</span> <span class="k">else</span> <span class="s1">&#39;cpu&#39;</span><span class="p">)</span>
<span class="n">device</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Drive already mounted at /content/gdrive; to attempt to forcibly remount, call drive.mount(&#34;/content/gdrive&#34;, force_remount=True).
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
device(type=&#39;cuda&#39;, index=0)
</pre></div></div>
</div>
<p>The cell should output something like:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>Mounted at /content/gdrive
device(type=&#39;cuda&#39;, index=0)
</pre></div>
</div>
<p>If the second line says <code class="docutils literal notranslate"><span class="pre">device(type='cpu')</span></code> then you should change your environment options above for GPU for faster results.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span># Imports:
# Libraries:
!pip install PyAstronomy
from torch.utils.data import DataLoader, Dataset
from datetime import datetime
import re
import random
import seaborn as sns
sns.set()

# SOH Modules:
# Battery Classes:
from Coin_Classes import *
from MIT_Classes import *
from Nasa_Classes import *
# Models:
from LSTM import *
import LSTM_chemistry as chem #
# Training and Report related:
from Training import *
from Load_Save import *
import DistributionPlots as dp
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Requirement already satisfied: PyAstronomy in /usr/local/lib/python3.7/dist-packages (0.16.0)
Requirement already satisfied: numpy in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.19.5)
Requirement already satisfied: six in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.15.0)
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Useful definitions:</span>
<span class="kn">import</span> <span class="nn">main</span>      <span class="c1"># Some dictionary definitions such as path_dict</span>

<span class="n">path_dict</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">path_dict</span>

<span class="c1"># Batteries to exclude from training and validation datasets:</span>
<span class="n">ignore_dict</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;NASA&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0049.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0050.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0051.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0052.txt&#39;</span><span class="p">],</span>
    <span class="s1">&#39;MIT&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span> <span class="mi">48</span><span class="p">)],</span>
    <span class="c1"># There are no problems with these ^ batteries, it&#39;s just that MIT&#39;s dataset</span>
    <span class="c1"># is huge, so I don&#39;t include all of the batteries in the validation dataset</span>
    <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0008.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0019.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0023.txt&#39;</span><span class="p">],</span>
<span class="p">}</span>

<span class="c1"># Batteries to include in the training dataset:</span>
<span class="n">train_dict</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;NASA&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0006.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0030.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0038.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0039.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0041.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0045.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0055.txt&#39;</span><span class="p">,],</span> <span class="c1"># 4ºC</span>
    <span class="s1">&#39;MIT&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">],</span>
    <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">,</span>
                      <span class="s1">&#39;B0004.txt&#39;</span><span class="p">,</span>
                      <span class="s1">&#39;B0014.txt&#39;</span><span class="p">,</span>
                      <span class="s1">&#39;B0016.txt&#39;</span><span class="p">]</span>
<span class="p">}</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># [0] # LSTM_v4, DELTA=10 reports:</span>

<span class="c1">#NASA</span>
<span class="n">report_name</span> <span class="o">=</span> <span class="s1">&#39;2021-08-06 09_22_32.468552-nasav4&#39;</span> <span class="c1">###</span>
<span class="c1"># getting the model from the report:</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/&#39;</span><span class="o">+</span><span class="n">report_name</span><span class="p">)</span>
<span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
    <span class="n">base_model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>
<span class="n">nasa_norm</span> <span class="o">=</span> <span class="n">chem</span><span class="o">.</span><span class="n">norm_adapt</span><span class="p">(</span><span class="n">base_model</span><span class="o">.</span><span class="n">norm</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;nasa_norm&#39;</span><span class="p">,</span> <span class="n">nasa_norm</span><span class="p">)</span>

<span class="c1">#MIT</span>
<span class="n">report_name</span> <span class="o">=</span> <span class="s1">&#39;2021-08-04 12_31_41.305058-mitv4&#39;</span>  <span class="c1">###</span>
<span class="c1"># getting the model from the report:</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/&#39;</span><span class="o">+</span><span class="n">report_name</span><span class="p">)</span>
<span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
    <span class="n">base_model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>

<span class="n">mit_norm</span> <span class="o">=</span> <span class="n">chem</span><span class="o">.</span><span class="n">norm_adapt</span><span class="p">(</span><span class="n">base_model</span><span class="o">.</span><span class="n">norm</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;mit_norm&#39;</span><span class="p">,</span> <span class="n">mit_norm</span><span class="p">)</span>

<span class="c1">#COIN</span>
<span class="n">report_name</span> <span class="o">=</span> <span class="s1">&#39;2021-08-04 13_33_09.035717-coinv4&#39;</span>  <span class="c1">###</span>
<span class="c1"># getting the model from the report:</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/&#39;</span><span class="o">+</span><span class="n">report_name</span><span class="p">)</span>
<span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
    <span class="n">base_model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>
<span class="n">coin_norm</span> <span class="o">=</span> <span class="n">chem</span><span class="o">.</span><span class="n">norm_adapt</span><span class="p">(</span><span class="n">base_model</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span> <span class="n">tech</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span> <span class="c1"># tech=1 because Na-ion</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;coin_norm&#39;</span><span class="p">,</span> <span class="n">coin_norm</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
nasa_norm (tensor([ 0.4417,  0.4377,  0.4338,  0.4299,  0.4259,  0.4221,  0.4183,  0.4145,
         0.4107,  0.4069,  0.9869,  0.9876,  0.9881,  0.9886,  0.9890,  0.9894,
         0.9898,  0.9901,  0.9905,  0.9908, 20.3975,  0.0000]), tensor([ 0.2395,  0.2398,  0.2400,  0.2402,  0.2404,  0.2406,  0.2408,  0.2410,
         0.2411,  0.2413,  0.0267,  0.0249,  0.0238,  0.0230,  0.0223,  0.0217,
         0.0212,  0.0207,  0.0203,  0.0199, 15.1578,  1.0000]), tensor([0.6211]), tensor([0.1952]), &#39;zscore&#39;)
mit_norm (tensor([ 0.7405,  0.7375,  0.7345,  0.7314,  0.7283,  0.7252,  0.7220,  0.7188,
         0.7155,  0.7123,  0.9729,  0.9732,  0.9736,  0.9739,  0.9743,  0.9747,
         0.9750,  0.9753,  0.9757,  0.9760, 30.0000,  0.0000]), tensor([0.2915, 0.2933, 0.2952, 0.2970, 0.2988, 0.3006, 0.3024, 0.3041, 0.3058,
        0.3075, 0.0208, 0.0207, 0.0206, 0.0205, 0.0205, 0.0204, 0.0203, 0.0203,
        0.0202, 0.0201, 1.0000, 1.0000]), tensor([0.9173]), tensor([0.0424]), &#39;zscore&#39;)
coin_norm (tensor([ 0.1856,  0.1856,  0.1856,  0.1856,  0.1856,  0.1856,  0.1856,  0.1856,
         0.1856,  0.1856,  0.7917,  0.7938,  0.7954,  0.7968,  0.7983,  0.7998,
         0.8012,  0.8027,  0.8041,  0.8055, 55.0000,  1.0000]), tensor([0.0233, 0.0233, 0.0233, 0.0233, 0.0233, 0.0233, 0.0233, 0.0233, 0.0233,
        0.0233, 0.0793, 0.0781, 0.0781, 0.0781, 0.0782, 0.0782, 0.0783, 0.0784,
        0.0785, 0.0786, 1.0000, 1.0000]), tensor([0.5156]), tensor([0.1718]), &#39;zscore&#39;)
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># initializing dataset related variables:</span>
<span class="n">fixed_len</span> <span class="o">=</span> <span class="mi">150</span>         <span class="c1">## Recommended values</span>
<span class="n">batch_size</span> <span class="o">=</span> <span class="mi">1</span>          <span class="c1">##</span>
<span class="n">adimensionalize</span><span class="o">=</span><span class="kc">True</span>    <span class="c1">##</span>
<span class="n">norm_type</span> <span class="o">=</span> <span class="s1">&#39;zscore&#39;</span>    <span class="c1">##</span>
<span class="n">DELTA</span> <span class="o">=</span> <span class="mi">10</span>              <span class="c1">###</span>

<span class="n">cycle_lim</span> <span class="o">=</span> <span class="mf">1e6</span>         <span class="c1">### depends on your analysis</span>
<span class="n">LSTM_version</span> <span class="o">=</span> <span class="mi">4</span>        <span class="c1">###</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Emptying dataset lists</span>
<span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="n">Valid_list</span> <span class="o">=</span> <span class="p">[]</span>
</pre></div>
</div>
</div>
<p><strong>NOTE: LSTM CHEMISTRY</strong></p>
<p>The following datasets and models are called from the <code class="docutils literal notranslate"><span class="pre">LSTM_chemistry</span></code> module (<code class="docutils literal notranslate"><span class="pre">chem.</span></code>). If you want to try mixing datasets for regular <code class="docutils literal notranslate"><span class="pre">LSTM</span></code> or <code class="docutils literal notranslate"><span class="pre">LSTM_with_norm</span></code>, you’ll have to change some things.</p>
<hr class="docutils" />
<p><strong>How to mix datasets</strong></p>
<p>In the next cell (<code class="docutils literal notranslate"><span class="pre">[1]</span></code>), pick a <code class="docutils literal notranslate"><span class="pre">dataset_name</span></code>, a <code class="docutils literal notranslate"><span class="pre">norm</span></code> dictionary and a <code class="docutils literal notranslate"><span class="pre">time_step</span></code> dictionary (optional).</p>
<p>By running the cell immediately after (<code class="docutils literal notranslate"><span class="pre">[2]</span></code>), batteries in <code class="docutils literal notranslate"><span class="pre">train_dict[dataset_name]</span></code> will be added to the <code class="docutils literal notranslate"><span class="pre">Train_list</span></code>, and the rest to <code class="docutils literal notranslate"><span class="pre">Valid_list</span></code>.</p>
<p>You can then change the <code class="docutils literal notranslate"><span class="pre">dataset_name</span></code>, <code class="docutils literal notranslate"><span class="pre">time_step</span></code> and <code class="docutils literal notranslate"><span class="pre">norm</span></code> (in <code class="docutils literal notranslate"><span class="pre">[1]</span></code>) and rerun the following cell (<code class="docutils literal notranslate"><span class="pre">[2]</span></code>). This way, batteries from this other dataset will be added to the dataset lists.</p>
<p>When you’re finished, run cell <code class="docutils literal notranslate"><span class="pre">[3]</span></code>, which will merge the datasets together accordingly and create a loader for each one.</p>
<hr class="docutils" />
<p><strong>About normalisation and time step</strong></p>
<p><strong>Notice that, because normalisation is different for each dataset, normalisation information isn’t easily accessible if you don’t save it.</strong> Also, if you leave <code class="docutils literal notranslate"><span class="pre">norm</span> <span class="pre">=</span> <span class="pre">None</span></code>, each battery will be normalised separately (with respect to itself - even for batteries from the same dataset), <strong>same goes for the ``time_step`` used</strong>. Recommended <code class="docutils literal notranslate"><span class="pre">time_step</span></code> values are given by default. It is recommended to get normalisation information for each dataset from reports (see cell <code class="docutils literal notranslate"><span class="pre">[0]</span></code>, three cells
up^). The default values won’t work for all LSTM types and delta values.</p>
<p>If you need to check the normalisation used for each case, you can use something like this:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>for dataset in Train_list:
    print(dataset.dataset_name)  # A string indicating the dataset (NASA, ...)
    print(dataset.batteries)     # The batteries used in this dataset (just one)
    print(dataset.norm)          # The normalisation info used/calculated
    print(dataset.time_step)     # The time step used/calculated
</pre></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># [1]</span>

<span class="c1">### the variables called here were defined with the other dictionaries^</span>
<span class="n">norm</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;NASA&#39;</span><span class="p">:</span> <span class="n">nasa_norm</span><span class="p">,</span> <span class="s1">&#39;MIT&#39;</span><span class="p">:</span> <span class="n">mit_norm</span><span class="p">,</span> <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">:</span> <span class="n">coin_norm</span><span class="p">}</span>

<span class="c1">### recommended: {NASA: 30, MIT: 3, Tarascon Coin: 30}</span>
<span class="n">time_step</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">default_time_step_dict</span> <span class="c1"># defined in main.py</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># [2]</span>
<span class="n">dataset_name</span> <span class="o">=</span> <span class="s1">&#39;Tarascon Coin&#39;</span>      <span class="c1">### NASA; MIT; Tarascon Coin.</span>

<span class="c1"># Dataset creation:</span>
<span class="k">try</span><span class="p">:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">path_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">])</span>
<span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
    <span class="k">raise</span> <span class="ne">FileNotFoundError</span><span class="p">(</span><span class="s2">&quot;Current directory: &quot;</span><span class="o">+</span><span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">())</span>

<span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>    <span class="c1"># All files in the folder</span>
<span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>          <span class="c1"># List with the valid files</span>

<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
    <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span> <span class="c1"># Only take into acount</span>
                                                <span class="c1"># the battery files</span>
    <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
<span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>

<span class="n">ignore</span> <span class="o">=</span> <span class="n">ignore_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>
<span class="n">train</span> <span class="o">=</span> <span class="n">train_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>

<span class="c1"># Training files:</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

        <span class="c1"># Here, Train_list is a list of datasets.</span>
        <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
            <span class="n">chem</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span><span class="p">(</span>
                <span class="p">[</span><span class="n">Battery</span><span class="p">],</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">],</span> <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span>
                <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">norm</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">],</span>
                <span class="n">adimensionalize</span><span class="o">=</span><span class="n">adimensionalize</span>
            <span class="p">)</span>
        <span class="p">)</span>

<span class="c1"># Validation files:</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">)</span> <span class="ow">and</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">):</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

        <span class="c1"># Here, Valid_list is a list of datasets.</span>
        <span class="n">Valid_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
            <span class="n">chem</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span><span class="p">(</span>
                <span class="p">[</span><span class="n">Battery</span><span class="p">],</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">],</span> <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span>
                <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">norm</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">],</span>
                <span class="n">adimensionalize</span><span class="o">=</span><span class="n">adimensionalize</span>
                <span class="p">)</span>
            <span class="p">)</span>

<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0001
B0001
303
B0004
B0004
47
B0014
52
B0016
B0016
85
B0002
B0002
77
B0003
B0003
64
B0005
83
B0006
B0006
72
B0009
30
B0010
B0010
52
B0011
30
B0012
B0012
5
B0013
34
B0015
B0015
62
B0017
B0017
110
B0018
55
B0020
15
B0021
23
B0022
20
B0024
17
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># [3]</span>
<span class="c1"># Merging datasets:</span>
<span class="n">train_dataset</span> <span class="o">=</span> <span class="n">chem</span><span class="o">.</span><span class="n">Torch_Dataset_Mixer</span><span class="p">(</span><span class="n">Train_list</span><span class="p">)</span>
<span class="n">valid_dataset</span> <span class="o">=</span> <span class="n">chem</span><span class="o">.</span><span class="n">Torch_Dataset_Mixer</span><span class="p">(</span><span class="n">Valid_list</span><span class="p">)</span>

<span class="c1"># Loaders:</span>
<span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="n">batch_size</span><span class="p">,</span>
                          <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">sim_train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span>
                              <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">train_dataset</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">valid_dataset</span><span class="p">),</span>
                          <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Model information:</span>
<span class="n">HIDDEN_DIM</span> <span class="o">=</span> <span class="mi">50</span>             <span class="c1">##</span>
<span class="n">DROPOUT</span> <span class="o">=</span> <span class="mi">0</span>                 <span class="c1">##</span>
<span class="n">pool_type</span> <span class="o">=</span> <span class="s1">&#39;bi_mean&#39;</span>       <span class="c1">##</span>

<span class="c1"># Defining the model</span>
<span class="n">Model</span> <span class="o">=</span> <span class="n">chem</span><span class="o">.</span><span class="n">LSTM_v4</span><span class="p">(</span>
    <span class="n">DELTA</span><span class="p">,</span> <span class="n">HIDDEN_DIM</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="n">pool_type</span><span class="p">,</span> <span class="n">drop_out</span><span class="o">=</span><span class="n">DROPOUT</span><span class="p">,</span>
    <span class="n">version</span> <span class="o">=</span> <span class="n">LSTM_version</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">lin_layers</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">lin_dropout</span><span class="o">=</span><span class="mf">0.5</span>
    <span class="c1"># train_dataset has no attribute &quot;norm&quot;</span>
    <span class="p">)</span>

<span class="n">Model</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>

<span class="c1"># Model&#39;s performance as is (should be bad) (useful for seeing the datasets)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">fixed_lims</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">fixed_lims</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="c1"># denormalize=False is necessary. train_dataset doesn&#39;t have information on</span>
<span class="c1"># normalisation because it&#39;s different for each dataset</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/rst_files_lstm_chemistry_training_13_0.png" src="../_images/rst_files_lstm_chemistry_training_13_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/rst_files_lstm_chemistry_training_13_1.png" src="../_images/rst_files_lstm_chemistry_training_13_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Training Loop:</span>
<span class="n">Nb_Epochs</span> <span class="o">=</span> <span class="mi">75</span>              <span class="c1">###</span>
<span class="n">Learning_Rate</span> <span class="o">=</span> <span class="mf">5e-6</span>        <span class="c1">###</span>


<span class="n">Train_info</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">date</span> <span class="o">=</span> <span class="n">Train</span><span class="p">(</span>
    <span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">Nb_Epochs</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">LR</span><span class="o">=</span><span class="n">Learning_Rate</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span>
    <span class="n">remove_bool</span><span class="o">=</span><span class="kc">True</span>
    <span class="p">)</span>

<span class="c1"># Best epoch&#39;s performance:</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">fixed_lims</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">fixed_lims</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
1 . Training loss:  tensor(0.9574)
1 . Validation loss:  tensor(0.6102)
2 . Training loss:  tensor(0.9533)
2 . Validation loss:  tensor(0.5989)
3 . Training loss:  tensor(0.9364)
3 . Validation loss:  tensor(0.5819)
4 . Training loss:  tensor(0.9183)
4 . Validation loss:  tensor(0.5563)
5 . Training loss:  tensor(0.9014)
5 . Validation loss:  tensor(0.5242)
6 . Training loss:  tensor(0.8745)
6 . Validation loss:  tensor(0.4881)
7 . Training loss:  tensor(0.8462)
7 . Validation loss:  tensor(0.4479)
8 . Training loss:  tensor(0.8156)
8 . Validation loss:  tensor(0.4083)
9 . Training loss:  tensor(0.7918)
9 . Validation loss:  tensor(0.3697)
10 . Training loss:  tensor(0.7675)
10 . Validation loss:  tensor(0.3344)
11 . Training loss:  tensor(0.7458)
11 . Validation loss:  tensor(0.3041)
12 . Training loss:  tensor(0.7227)
12 . Validation loss:  tensor(0.2767)
13 . Training loss:  tensor(0.7082)
13 . Validation loss:  tensor(0.2547)
14 . Training loss:  tensor(0.6866)
14 . Validation loss:  tensor(0.2341)
15 . Training loss:  tensor(0.6703)
15 . Validation loss:  tensor(0.2141)
16 . Training loss:  tensor(0.6607)
16 . Validation loss:  tensor(0.1978)
17 . Training loss:  tensor(0.6317)
17 . Validation loss:  tensor(0.1857)
18 . Training loss:  tensor(0.6305)
18 . Validation loss:  tensor(0.1765)
19 . Training loss:  tensor(0.6069)
19 . Validation loss:  tensor(0.1697)
20 . Training loss:  tensor(0.5999)
20 . Validation loss:  tensor(0.1617)
21 . Training loss:  tensor(0.5892)
21 . Validation loss:  tensor(0.1557)
22 . Training loss:  tensor(0.5702)
22 . Validation loss:  tensor(0.1491)
23 . Training loss:  tensor(0.5413)
23 . Validation loss:  tensor(0.1435)
24 . Training loss:  tensor(0.5336)
24 . Validation loss:  tensor(0.1396)
25 . Training loss:  tensor(0.5267)
25 . Validation loss:  tensor(0.1345)
26 . Training loss:  tensor(0.5214)
26 . Validation loss:  tensor(0.1305)
27 . Training loss:  tensor(0.5118)
27 . Validation loss:  tensor(0.1277)
28 . Training loss:  tensor(0.4874)
28 . Validation loss:  tensor(0.1262)
29 . Training loss:  tensor(0.4704)
29 . Validation loss:  tensor(0.1238)
30 . Training loss:  tensor(0.4601)
30 . Validation loss:  tensor(0.1199)
31 . Training loss:  tensor(0.4495)
31 . Validation loss:  tensor(0.1175)
32 . Training loss:  tensor(0.4239)
32 . Validation loss:  tensor(0.1160)
33 . Training loss:  tensor(0.4174)
33 . Validation loss:  tensor(0.1126)
34 . Training loss:  tensor(0.4010)
34 . Validation loss:  tensor(0.1113)
35 . Training loss:  tensor(0.3814)
35 . Validation loss:  tensor(0.1080)
36 . Training loss:  tensor(0.3704)
36 . Validation loss:  tensor(0.1082)
37 . Training loss:  tensor(0.3598)
37 . Validation loss:  tensor(0.1040)
38 . Training loss:  tensor(0.3468)
38 . Validation loss:  tensor(0.1056)
39 . Training loss:  tensor(0.3199)
39 . Validation loss:  tensor(0.1033)
40 . Training loss:  tensor(0.3168)
40 . Validation loss:  tensor(0.1049)
41 . Training loss:  tensor(0.3157)
41 . Validation loss:  tensor(0.1072)
42 . Training loss:  tensor(0.2958)
42 . Validation loss:  tensor(0.1059)
43 . Training loss:  tensor(0.2999)
43 . Validation loss:  tensor(0.1087)
44 . Training loss:  tensor(0.2855)
44 . Validation loss:  tensor(0.1113)
45 . Training loss:  tensor(0.2904)
45 . Validation loss:  tensor(0.1125)
46 . Training loss:  tensor(0.2872)
46 . Validation loss:  tensor(0.1134)
47 . Training loss:  tensor(0.2808)
47 . Validation loss:  tensor(0.1090)
48 . Training loss:  tensor(0.2650)
48 . Validation loss:  tensor(0.1102)
49 . Training loss:  tensor(0.2644)
49 . Validation loss:  tensor(0.1128)
50 . Training loss:  tensor(0.2720)
50 . Validation loss:  tensor(0.1122)
51 . Training loss:  tensor(0.2624)
51 . Validation loss:  tensor(0.1110)
52 . Training loss:  tensor(0.2550)
52 . Validation loss:  tensor(0.1189)
53 . Training loss:  tensor(0.2474)
53 . Validation loss:  tensor(0.1131)
54 . Training loss:  tensor(0.2531)
54 . Validation loss:  tensor(0.1119)
55 . Training loss:  tensor(0.2515)
55 . Validation loss:  tensor(0.1086)
56 . Training loss:  tensor(0.2540)
56 . Validation loss:  tensor(0.1098)
57 . Training loss:  tensor(0.2388)
57 . Validation loss:  tensor(0.1094)
58 . Training loss:  tensor(0.2431)
58 . Validation loss:  tensor(0.1073)
59 . Training loss:  tensor(0.2397)
59 . Validation loss:  tensor(0.1086)
60 . Training loss:  tensor(0.2503)
60 . Validation loss:  tensor(0.1083)
61 . Training loss:  tensor(0.2333)
61 . Validation loss:  tensor(0.1077)
62 . Training loss:  tensor(0.2518)
62 . Validation loss:  tensor(0.1075)
63 . Training loss:  tensor(0.2483)
63 . Validation loss:  tensor(0.1037)
64 . Training loss:  tensor(0.2317)
64 . Validation loss:  tensor(0.1046)
65 . Training loss:  tensor(0.2274)
65 . Validation loss:  tensor(0.1020)
66 . Training loss:  tensor(0.2229)
66 . Validation loss:  tensor(0.0996)
67 . Training loss:  tensor(0.2143)
67 . Validation loss:  tensor(0.0997)
68 . Training loss:  tensor(0.2180)
68 . Validation loss:  tensor(0.1007)
69 . Training loss:  tensor(0.2198)
69 . Validation loss:  tensor(0.0980)
70 . Training loss:  tensor(0.2146)
70 . Validation loss:  tensor(0.0993)
71 . Training loss:  tensor(0.2169)
71 . Validation loss:  tensor(0.0972)
72 . Training loss:  tensor(0.2177)
72 . Validation loss:  tensor(0.0984)
73 . Training loss:  tensor(0.2161)
73 . Validation loss:  tensor(0.0957)
74 . Training loss:  tensor(0.2122)
74 . Validation loss:  tensor(0.0960)
75 . Training loss:  tensor(0.2164)
75 . Validation loss:  tensor(0.0950)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/rst_files_lstm_chemistry_training_14_1.png" src="../_images/rst_files_lstm_chemistry_training_14_1.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Best validation error:  75
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/rst_files_lstm_chemistry_training_14_3.png" src="../_images/rst_files_lstm_chemistry_training_14_3.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/rst_files_lstm_chemistry_training_14_4.png" src="../_images/rst_files_lstm_chemistry_training_14_4.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Calculating the model&#39;s error for each battery for each dataset:</span>
<span class="c1"># You&#39;ll have to define time_step and norm for each dataset</span>


<span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="p">[</span><span class="s1">&#39;NASA&#39;</span><span class="p">,</span> <span class="s1">&#39;MIT&#39;</span><span class="p">,</span> <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">]:</span>
    <span class="n">Load_Save_v2</span><span class="p">(</span>
        <span class="n">date</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">[</span><span class="n">name</span><span class="p">],</span>
        <span class="n">norm_test</span><span class="o">=</span><span class="n">norm</span><span class="p">[</span><span class="n">name</span><span class="p">],</span> <span class="n">denormalize_bool</span><span class="o">=</span><span class="kc">True</span>
        <span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0005
165
B0006
166
B0007
165
B0018
130
B0025
27
B0026
24
B0027
27
B0028
27
B0029
40
B0030
40
B0031
40
B0032
40
B0033
181
B0034
189
B0036
193
B0038
44
B0039
42
B0040
43
B0041
25
B0042
64
B0043
64
B0044
65
B0045
68
B0046
66
B0047
67
B0048
68
B0053
55
B0054
101
B0055
98
B0000
280
B0001
130
B0002
426
B0003
313
B0004
427
B0005
465
B0006
457
B0007
522
B0008
829
B0009
951
B0010
534
B0011
461
B0012
432
B0013
460
B0014
471
B0015
126
B0016
382
B0017
477
B0018
466
B0019
443
B0020
487
B0021
475
B0022
501
B0023
509
B0024
205
B0025
152
B0026
186
B0027
454
B0028
494
B0029
483
B0030
465
B0031
477
B0032
506
B0033
507
B0034
485
B0035
449
B0036
524
B0037
468
B0038
455
B0039
449
B0040
479
B0041
416
B0042
450
B0043
447
B0044
444
B0045
470
B0046
420
B0047
676
B0001
B0001
303
B0002
B0002
77
B0003
B0003
64
B0004
B0004
47
B0005
83
B0006
B0006
72
B0009
30
B0010
B0010
52
B0011
30
B0012
B0012
5
B0013
34
B0014
52
B0015
B0015
62
B0016
B0016
85
B0017
B0017
110
B0018
55
B0020
15
B0021
23
B0022
20
B0024
17
</pre></div></div>
</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="normalisation_training.html" title="previous page"><strong>Normalisation Training Colab</strong></a>
    <a class='right-next' id="next-link" href="main.html" title="next page">Useful Dictionaries</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>